madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

more arch-handling fixes
[code/mbuild.git] / sbuild-wrapper.sh
index be866e7..57dcaa6 100755 (executable)
@@ -2,7 +2,7 @@
 #
 #  - automate builds with sbuild and dinstall the result
 #
 #
 #  - automate builds with sbuild and dinstall the result
 #
-# Copyright (c) 2008 martin f. krafft <madduck@debian.org>
+# Copyright (c) 2008–2010 martin f. krafft <madduck@debian.org>
 # Released under the terms of the Artistic Licence 2.0.
 #
 set -eu
 # Released under the terms of the Artistic Licence 2.0.
 #
 set -eu
@@ -10,7 +10,11 @@ set -eu
 ME="${0##*/}"
 
 BUILDDIR="$(mktemp -dt $ME.XXXXXXXX)"
 ME="${0##*/}"
 
 BUILDDIR="$(mktemp -dt $ME.XXXXXXXX)"
-trap "cd /tmp && rm -r '$BUILDDIR'" 0
+cleanup() {
+  cd /tmp && rm -r "$BUILDDIR"
+  trap - 1 2 3 4 5 6 7 8 10 11 12 13 14 15
+}
+trap cleanup 1 2 3 4 5 6 7 8 10 11 12 13 14 15
 
 BUNDLE_DIR="${TMPDIR:-/tmp}"
 TARGET_DIR="$PWD"
 
 BUNDLE_DIR="${TMPDIR:-/tmp}"
 TARGET_DIR="$PWD"
@@ -24,6 +28,9 @@ dinstall() {
 print_bundle_location() {
   echo "Bundle available at $@ ."
 }
 print_bundle_location() {
   echo "Bundle available at $@ ."
 }
+postbuild() {
+  :
+}
 
 KEYID=
 
 
 KEYID=
 
@@ -65,6 +72,7 @@ usage()
 
 binonly=0
 sbuild_args=
 
 binonly=0
 sbuild_args=
+sbuild_args_sourceful=
 schangesfile=
 arch=
 for opt in "$@"; do
 schangesfile=
 arch=
 for opt in "$@"; do
@@ -101,8 +109,6 @@ if [ -z "$schangesfile" ]; then
   exit 1
 fi
 
   exit 1
 fi
 
-[ -z "$arch" ] && arch="$DEB_BUILD_ARCH"
-
 dist="$(sed -ne 's,Distribution: ,,p' "$schangesfile")"
 
 schangesfile_basename="${schangesfile##*/}"
 dist="$(sed -ne 's,Distribution: ,,p' "$schangesfile")"
 
 schangesfile_basename="${schangesfile##*/}"
@@ -146,34 +152,82 @@ dcmd "$dscfile_basename" | while read f; do
   esac
 done
 
   esac
 done
 
-[ "$binonly" = 0 ] && sbuild_args="${sbuild_args:+$sbuild_args }--source --arch-all"
+rm $schangesfile
+unset schangesfile
 
 
-sbuild $sbuild_args --arch="$arch" --dist="$dist" --keyid=$KEYID \
-  "$dscfile_basename"
+[ -z "$arch" ] && arch="$DEB_BUILD_ARCH"
 
 
-changesfile="${packagenameversion}_${arch}.changes"
+target_arch="$(sed -ne 's,^Architecture: ,,p' $dscfile_basename)"
+case "$binonly/$target_arch" in
+  1/all)
+    echo "E: cannot build arch:all packages with -B." >&2
+    exit 1
+    ;;
+  0/all) arch=all;;
+  */any)
+    arch="$(schroot -l | sed -rne 's,^sid-([^-]+).*,\1,p' | uniq | tr '\n' ' ')"
+    ;;
+esac
 
 
-#mergechanges "$schangesfile" "$changesfile" > temp-combined.changes
-#mv temp-combined.changes "$changesfile"
-#changestool "$changesfile" updatechecksums
+if [ "$binonly" = 0 ]; then
+  sbuild_args_sourceful="--source"
+fi
 
 
-#sign_changes_file "$changesfile"
+for a in $arch; do
+  echo "I: building $packagenameversion for $a/$dist…" >&2
 
 
-dinstall "$dist" "$changesfile"
+  case "$a" in
+    all)
+      arch_arg=--arch-all
+      a="$DEB_BUILD_ARCH"
+      ;;
+    *) arch_arg="--arch=$a";;
+  esac
 
 
-DATESTR="$(date +%Y.%m.%d.%H%M%S)"
-BUILD_PREFIX="${packagenameversion}_${arch}.${DATESTR}"
+  sbuild $sbuild_args $sbuild_args_sourceful \
+    $arch_arg --dist="$dist" --keyid=$KEYID \
+    "$dscfile_basename" || ret=$?
 
 
-mv current "${BUILD_PREFIX}".buildlog
-rm -f current-*
+  changesfile="${packagenameversion}_${a}.changes"
 
 
-bundle="${BUNDLE_DIR}/${BUILD_PREFIX}".bundle.tar
-tar -chf "$bundle" *
-chmod 644 "$bundle"
+  if [ -n "$sbuild_args_sourceful" ]; then
+    schangesfile="${packagenameversion}_source+${changesfile#${packagenameversion}_}"
+    mv "$changesfile" "$schangesfile"
+    changesfile="$schangesfile"
+  fi
+
+  # subsequent iterations should be binonly
+  sbuild_args_sourceful=
+
+  echo "I: running post-build hook ($packagenameversion/$a/$dist)…" >&2
+  postbuild "$dist" "$a" "$changesfile"
+  echo "I: running dinstall ($packagenameversion/$a/$dist)…" >&2
+  dinstall "$dist" "$changesfile"
+
+  echo "I: done building $packagenameversion for $a/$dist" >&2
+done
 
 
-rm -r "$BUILDDIR"
-trap - 0
+if [ -n "${schangesfile:-}" ]; then
+  sarch="${schangesfile##*_}"; sarch=${sarch%.changes}
+  other_archs="$(for i in *.changes; do
+                   [ "$i" = "$schangesfile" ] && continue
+                   t="${i##*_}"; echo "${t%.changes}"
+                 done)"
+
+  if [ -n "$other_archs" ]; then
+    combined_arch="${sarch}+${other_archs}"
+    mergechanges *.changes > ${packagenameversion}_${combined_arch}.changes
+    arch="$combined_arch"
+  else
+    arch="$sarch"
+  fi
+fi
 
 
+bundle="${BUNDLE_DIR}/${packagenameversion}_${arch}_bundle.tar.gz"
+tar -chzf "$bundle" *
+chmod 644 "$bundle"
 print_bundle_location "$bundle"
 
 print_bundle_location "$bundle"
 
+cleanup
+
 exit 0
 exit 0